#include "buffer_pair.hpp"

namespace xmlioserver
{
   namespace comm
   {
      /// ////////////////////// Définitions ////////////////////// ///
      CBufferPair::CBufferPair(MPIComm com_client_server)
         : com_client_server(com_client_server) 
         , first(BUFFER_CLIENT_SIZE), second(BUFFER_CLIENT_SIZE)
         , first_request(-1), second_request(-1)
         , currentBuffer(0)
      { /* Ne rien faire de plus */ }

      CBufferPair::~CBufferPair(void)
      { /* Ne rien faire de plus */ }

      ///--------------------------------------------------------------

      bool CBufferPair::mustBeSent(void)
      {
         if (((currentBuffer  ==  0) && (first.getUsedSize()  != 0) &&
             ((second_request == -1) || CMPIManager::Test (second_request))) ||
             ((currentBuffer  ==  1) && (second.getUsedSize() != 0) &&
             ((first_request  == -1) || CMPIManager::Test (first_request))))
            return (true);
         return (false);
      }
      
      //---------------------------------------------------------------
      
      void CBufferPair::wait(void)
      {
         if (this->currentBuffer == 0)
              CMPIManager::Wait(this->second_request);
         else CMPIManager::Wait(this->first_request);
      }
      
      //---------------------------------------------------------------
      
      void CBufferPair::sendCurrentBuffer(void)
      {
         if (this->currentBuffer == 0)
         {
            CMPIManager::SendLinearBuffer
               (this->com_client_server, 0, this->first, this->first_request);
            this->currentBuffer = 1;
            this->second.clear();
         }
         else
         {
            CMPIManager::SendLinearBuffer
               (this->com_client_server, 0, this->second, this->second_request);
            this->currentBuffer = 0;
            this->first.clear();
         }
      }
      
      //---------------------------------------------------------------
      
      CLinearBuffer & CBufferPair::getCurrentBuffer(void)
      {
         if (currentBuffer == 0) return (this->first);
         return (this->second);
      }
      
      ///--------------------------------------------------------------

   } // namespace tree
} // namespace xmlioserver

